﻿Imports System.Threading
Public Class Form1
    Private canceled As Boolean = False
    Private count As Integer = 0
    Private workerThread As Thread
    Private mre As ManualResetEvent = New ManualResetEvent(True)
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Button1.Enabled = False
        Button2.Enabled = True
        canceled = False
        ClearCount()

        workerThread = New Thread(New ThreadStart(AddressOf Work))
        workerThread.IsBackground = True
        workerThread.Start()
    End Sub
    Private Sub Work()
        Try
            Dim i As Integer
            For i = 1 To 10
                Me.Invoke(Sub() IncrementCount())
                Thread.Sleep(3000)  'この処理を実際の時間がかかる処理に置き換える
                mre.WaitOne()
                If canceled Then
                    Me.Invoke(Sub() ThreadCompleted(1))
                    Exit Sub
                End If
            Next
            Me.Invoke(Sub() ThreadCompleted(0))
        Catch ex As Exception
            Me.Invoke(Sub() ThreadCompleted(2))
        End Try
    End Sub
    Private Sub ThreadCompleted(ByVal state As Integer)
        If state = 0 Then
            MessageBox.Show("正常終了", "情報", MessageBoxButtons.OK, MessageBoxIcon.Information)
        ElseIf state = 1 Then
            ClearCount()
            MessageBox.Show("中断", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            ClearCount()
            MessageBox.Show("異常終了", "エラー", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
        Button1.Enabled = True
        Button2.Enabled = False
        canceled = False
        workerThread = Nothing
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        mre.Reset()
        Try
            If MessageBox.Show("中止しますか？", "質問", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                canceled = True
                Button2.Enabled = False
            End If
        Finally
            mre.Set()
        End Try
    End Sub
    Private Sub Form1_FormClosing(ByVal sender As System.Object,
        ByVal e As System.Windows.Forms.FormClosingEventArgs) _
        Handles MyBase.FormClosing
        If workerThread IsNot Nothing Then e.Cancel = True
    End Sub
    Private Sub ClearCount()
        count = 0
        UpdateText()
    End Sub
    Private Sub IncrementCount()
        count = count + 1
        UpdateText()
    End Sub
    Private Sub UpdateText()
        Label1.Text = String.Format("時間のかかる処理を実行中。{0}/10", count)
    End Sub
End Class
